//The Intermediate Layer for the Assembly Planner (ILAP)

//Provides a set of tools to be able to talk with the Assembly Planner from the University of Seville

#ifndef ILAP_HH
#define ILAP_HH

#include <WorldBase.hh>
#include <Entity.hh>

#include <msgClient.hh>

class ILAP{
private:
	msgClient client;
	
	//TODO
	unsigned int lastID;
	std::map<unsigned int, std::string> pieces;
//	std::string structure;
	
	ILAP(): lastID(0) {};
	ILAP(const ILAP&);
	ILAP operator=(const ILAP&);

	void validateName(std::string& name) const;
	std::string requestPlan(std::string const& structure);
	std::string requestREPlan();
	
public:
	//TODO
	std::string error_on_part;

	static ILAP& getInstance(){ //ILAP is a singleton
		static ILAP instance;
		
		return instance;
	}

	bool connect(const std::string& server, unsigned int port);

	bool updateWorldBaseWithAssemblyPlan(WorldBase& wb, Entity* structure);
//	bool REPLAN_updateWorldBaseWithAssemblyPlan(WorldBase& wb);
};

#endif //ILAP_HH
